/[gentoo-x86]/eclass/autotools.eclass
Gentoo

Contents of /eclass/autotools.eclass

Parent Directory Parent Directory | Revision Log Revision Log


Revision 1.101 - (show annotations) (download)
Sat Aug 21 19:39:52 2010 UTC (4 years, 5 months ago) by vapier
Branch: MAIN
Changes since 1.100: +1 -3 lines
remove unused references to long dead (circa 2006) AT_GNUCONF_UPDATE variable

1 # Copyright 1999-2010 Gentoo Foundation
2 # Distributed under the terms of the GNU General Public License v2
3 # $Header: /var/cvsroot/gentoo-x86/eclass/autotools.eclass,v 1.100 2010/08/21 19:36:45 vapier Exp $
4
5 # @ECLASS: autotools.eclass
6 # @MAINTAINER:
7 # base-system@gentoo.org
8 # @BLURB: Regenerates auto* build scripts
9 # @DESCRIPTION:
10 # This eclass is for safely handling autotooled software packages that need to
11 # regenerate their build scripts. All functions will abort in case of errors.
12 #
13 # NB: If you add anything, please comment it!
14
15 inherit eutils libtool
16
17 # @ECLASS-VARIABLE: WANT_AUTOCONF
18 # @DESCRIPTION:
19 # The major version of autoconf your package needs
20 : ${WANT_AUTOCONF:=latest}
21
22 # @ECLASS-VARIABLE: WANT_AUTOMAKE
23 # @DESCRIPTION:
24 # The major version of automake your package needs
25 : ${WANT_AUTOMAKE:=latest}
26
27 # @ECLASS-VARIABLE: _LATEST_AUTOMAKE
28 # @INTERNAL
29 # @DESCRIPTION:
30 # CONSTANT!
31 # The latest major version/slot of automake available on each arch.
32 # If a newer version is stable on any arch, and is NOT reflected in this list,
33 # then circular dependencies may arise during emerge @system bootstraps.
34 # Do NOT change this variable in your ebuilds!
35 _LATEST_AUTOMAKE='1.11'
36
37 _automake_atom="sys-devel/automake"
38 _autoconf_atom="sys-devel/autoconf"
39 if [[ -n ${WANT_AUTOMAKE} ]]; then
40 case ${WANT_AUTOMAKE} in
41 none) _automake_atom="" ;; # some packages don't require automake at all
42 # if you change the "latest" version here, change also autotools_run_tool
43 # this MUST reflect the latest stable major version for each arch!
44 latest) _automake_atom="|| ( `printf '=sys-devel/automake-%s* ' ${_LATEST_AUTOMAKE}` )" ;;
45 *) _automake_atom="=sys-devel/automake-${WANT_AUTOMAKE}*" ;;
46 esac
47 export WANT_AUTOMAKE
48 fi
49
50 if [[ -n ${WANT_AUTOCONF} ]] ; then
51 case ${WANT_AUTOCONF} in
52 none) _autoconf_atom="" ;; # some packages don't require autoconf at all
53 2.1) _autoconf_atom="=sys-devel/autoconf-${WANT_AUTOCONF}*" ;;
54 # if you change the “latest” version here, change also autotools_run_tool
55 latest|2.5) _autoconf_atom=">=sys-devel/autoconf-2.61" ;;
56 *) _autoconf_atom="INCORRECT-WANT_AUTOCONF-SETTING-IN-EBUILD" ;;
57 esac
58 export WANT_AUTOCONF
59 fi
60
61 AUTOTOOLS_DEPEND="${_automake_atom} ${_autoconf_atom}"
62 [[ ${CATEGORY}/${PN} != "sys-devel/libtool" ]] && AUTOTOOLS_DEPEND="${AUTOTOOLS_DEPEND} >=sys-devel/libtool-2.2.6b"
63 RDEPEND=""
64
65 # @ECLASS-VARIABLE: AUTOTOOLS_AUTO_DEPEND
66 # @DESCRIPTION:
67 # Set to 'no' to disable automatically adding to DEPEND. This lets
68 # ebuilds former conditional depends by using ${AUTOTOOLS_DEPEND} in
69 # their own DEPEND string.
70 : ${AUTOTOOLS_AUTO_DEPEND:=yes}
71 if [[ ${AUTOTOOLS_AUTO_DEPEND} != "no" ]] ; then
72 DEPEND=${AUTOTOOLS_DEPEND}
73 fi
74
75 unset _automake_atom _autoconf_atom
76
77 # @ECLASS-VARIABLE: AM_OPTS
78 # @DEFAULT_UNSET
79 # @DESCRIPTION:
80 # Additional options to pass to automake during
81 # eautoreconf call.
82
83 # @ECLASS-VARIABLE: AT_NOELIBTOOLIZE
84 # @DEFAULT_UNSET
85 # @DESCRIPTION:
86 # Don't run elibtoolize command if set to 'yes',
87 # useful when elibtoolize needs to be ran with
88 # particular options
89
90 # XXX: M4DIR should be deprecated
91 # @ECLASS-VARIABLE: AT_M4DIR
92 # @DESCRIPTION:
93 # Additional director(y|ies) aclocal should search
94 : ${AT_M4DIR:=${M4DIR}}
95
96 # @FUNCTION: eautoreconf
97 # @DESCRIPTION:
98 # This function mimes the behavior of autoreconf, but uses the different
99 # eauto* functions to run the tools. It doesn't accept parameters, but
100 # the directory with include files can be specified with AT_M4DIR variable.
101 #
102 # Should do a full autoreconf - normally what most people will be interested in.
103 # Also should handle additional directories specified by AC_CONFIG_SUBDIRS.
104 eautoreconf() {
105 local x auxdir g
106
107 if [[ -z ${AT_NO_RECURSIVE} ]]; then
108 # Take care of subdirs
109 for x in $(autotools_get_subdirs); do
110 if [[ -d ${x} ]] ; then
111 pushd "${x}" >/dev/null
112 AT_NOELIBTOOLIZE="yes" eautoreconf
113 popd >/dev/null
114 fi
115 done
116 fi
117
118 auxdir=$(autotools_get_auxdir)
119
120 einfo "Running eautoreconf in '${PWD}' ..."
121 [[ -n ${auxdir} ]] && mkdir -p ${auxdir}
122 eaclocal
123 [[ ${CHOST} == *-darwin* ]] && g=g
124 if ${LIBTOOLIZE:-${g}libtoolize} -n --install >& /dev/null ; then
125 _elibtoolize --copy --force --install
126 else
127 _elibtoolize --copy --force
128 fi
129 eautoconf
130 eautoheader
131 FROM_EAUTORECONF="yes" eautomake ${AM_OPTS}
132
133 [[ ${AT_NOELIBTOOLIZE} == "yes" ]] && return 0
134
135 # Call it here to prevent failures due to elibtoolize called _before_
136 # eautoreconf. We set $S because elibtoolize runs on that #265319
137 S=${PWD} elibtoolize
138
139 return 0
140 }
141
142 # @FUNCTION: eaclocal
143 # @DESCRIPTION:
144 # These functions runs the autotools using autotools_run_tool with the
145 # specified parametes. The name of the tool run is the same of the function
146 # without e prefix.
147 # They also force installing the support files for safety.
148 # Respects AT_M4DIR for additional directories to search for macro's.
149 eaclocal() {
150 local aclocal_opts
151
152 local amflags_file
153 for amflags_file in GNUmakefile.am Makefile.am GNUmakefile.in Makefile.in ; do
154 [[ -e ${amflags_file} ]] || continue
155 aclocal_opts=$(sed -n '/^ACLOCAL_AMFLAGS[[:space:]]*=/s:[^=]*=::p' ${amflags_file})
156 eval aclocal_opts=\"${aclocal_opts}\"
157 break
158 done
159
160 if [[ -n ${AT_M4DIR} ]] ; then
161 for x in ${AT_M4DIR} ; do
162 case "${x}" in
163 "-I")
164 # We handle it below
165 ;;
166 *)
167 [[ ! -d ${x} ]] && ewarn "eaclocal: '${x}' does not exist"
168 aclocal_opts="${aclocal_opts} -I ${x}"
169 ;;
170 esac
171 done
172 fi
173
174 [[ ! -f aclocal.m4 || -n $(grep -e 'generated.*by aclocal' aclocal.m4) ]] && \
175 autotools_run_tool aclocal "$@" ${aclocal_opts}
176 }
177
178 # @FUNCTION: _elibtoolize
179 # @DESCRIPTION:
180 # Runs libtoolize. Note the '_' prefix .. to not collide with elibtoolize() from
181 # libtool.eclass.
182 _elibtoolize() {
183 local opts g=
184
185 # Check if we should run libtoolize (AM_PROG_LIBTOOL is an older macro,
186 # check for both it and the current AC_PROG_LIBTOOL)
187 [[ -n $(autotools_check_macro AC_PROG_LIBTOOL AM_PROG_LIBTOOL LT_INIT) ]] || return 0
188
189 [[ -f GNUmakefile.am || -f Makefile.am ]] && opts="--automake"
190
191 [[ ${CHOST} == *-darwin* ]] && g=g
192 autotools_run_tool ${LIBTOOLIZE:-${g}libtoolize} "$@" ${opts}
193
194 # Need to rerun aclocal
195 eaclocal
196 }
197
198 # @FUNCTION: eautoheader
199 # @DESCRIPTION:
200 # Runs autoheader.
201 eautoheader() {
202 # Check if we should run autoheader
203 [[ -n $(autotools_check_macro "AC_CONFIG_HEADERS") ]] || return 0
204 NO_FAIL=1 autotools_run_tool autoheader "$@"
205 }
206
207 # @FUNCTION: eautoconf
208 # @DESCRIPTION:
209 # Runs autoconf.
210 eautoconf() {
211 if [[ ! -f configure.ac && ! -f configure.in ]] ; then
212 echo
213 eerror "No configure.{ac,in} present in '${PWD}'!"
214 echo
215 die "No configure.{ac,in} present!"
216 fi
217
218 autotools_run_tool autoconf "$@"
219 }
220
221 # @FUNCTION: eautomake
222 # @DESCRIPTION:
223 # Runs automake.
224 eautomake() {
225 local extra_opts
226 local makefile_name
227
228 # Run automake if:
229 # - a Makefile.am type file exists
230 # - a Makefile.in type file exists and the configure
231 # script is using the AM_INIT_AUTOMAKE directive
232 for makefile_name in {GNUmakefile,{M,m}akefile}.{am,in} "" ; do
233 [[ -f ${makefile_name} ]] && break
234 done
235 [[ -z ${makefile_name} ]] && return 0
236
237 if [[ ${makefile_name} == *.in ]] ; then
238 if ! grep -qs AM_INIT_AUTOMAKE configure.?? ; then
239 return 0
240 fi
241
242 elif [[ -z ${FROM_EAUTORECONF} && -f ${makefile_name%.am}.in ]]; then
243 local used_automake
244 local installed_automake
245
246 installed_automake=$(WANT_AUTOMAKE= automake --version | head -n 1 | \
247 sed -e 's:.*(GNU automake) ::')
248 used_automake=$(head -n 1 < ${makefile_name%.am}.in | \
249 sed -e 's:.*by automake \(.*\) from .*:\1:')
250
251 if [[ ${installed_automake} != ${used_automake} ]]; then
252 einfo "Automake used for the package (${used_automake}) differs from"
253 einfo "the installed version (${installed_automake})."
254 eautoreconf
255 return 0
256 fi
257 fi
258
259 [[ -f INSTALL && -f AUTHORS && -f ChangeLog && -f NEWS ]] \
260 || extra_opts="${extra_opts} --foreign"
261
262 # --force-missing seems not to be recognized by some flavours of automake
263 autotools_run_tool automake --add-missing --copy ${extra_opts} "$@"
264 }
265
266 # @FUNCTION: eautopoint
267 # @DESCRIPTION:
268 # Runs autopoint (from the gettext package).
269 eautopoint() {
270 autotools_run_tool autopoint "$@"
271 }
272
273 # Internal function to run an autotools' tool
274 autotools_run_tool() {
275 if [[ ${EBUILD_PHASE} != "unpack" && ${EBUILD_PHASE} != "prepare" ]]; then
276 ewarn "QA Warning: running $1 in ${EBUILD_PHASE} phase"
277 fi
278
279 # We do the “latest” → version switch here because it solves
280 # possible order problems, see bug #270010 as an example.
281 if [[ ${WANT_AUTOMAKE} == "latest" ]]; then
282 local pv
283 for pv in ${_LATEST_AUTOMAKE} ; do
284 # has_version respects ROOT, but in this case, we don't want it to,
285 # thus "ROOT=/" prefix:
286 ROOT=/ has_version "=sys-devel/automake-${pv}*" && export WANT_AUTOMAKE="$pv"
287 done
288 [[ ${WANT_AUTOMAKE} == "latest" ]] && \
289 die "Cannot find the latest automake! Tried ${_LATEST_AUTOMAKE}"
290 fi
291 [[ ${WANT_AUTOCONF} == "latest" ]] && export WANT_AUTOCONF=2.5
292
293 local STDERR_TARGET="${T}/$1.out"
294 # most of the time, there will only be one run, but if there are
295 # more, make sure we get unique log filenames
296 if [[ -e ${STDERR_TARGET} ]] ; then
297 STDERR_TARGET="${T}/$1-$$.out"
298 fi
299
300 printf "***** $1 *****\n***** PWD: ${PWD}\n***** $*\n\n" > "${STDERR_TARGET}"
301
302 ebegin "Running $@"
303 "$@" >> "${STDERR_TARGET}" 2>&1
304 eend $?
305
306 if [[ $? != 0 && ${NO_FAIL} != 1 ]] ; then
307 echo
308 eerror "Failed Running $1 !"
309 eerror
310 eerror "Include in your bugreport the contents of:"
311 eerror
312 eerror " ${STDERR_TARGET}"
313 echo
314 die "Failed Running $1 !"
315 fi
316 }
317
318 # Internal function to check for support
319 autotools_check_macro() {
320 [[ -f configure.ac || -f configure.in ]] || return 0
321 local macro
322 for macro ; do
323 WANT_AUTOCONF="2.5" autoconf --trace="${macro}" 2>/dev/null
324 done
325 return 0
326 }
327
328 # Internal function to get additional subdirs to configure
329 autotools_get_subdirs() {
330 local subdirs_scan_out
331
332 subdirs_scan_out=$(autotools_check_macro "AC_CONFIG_SUBDIRS")
333 [[ -n ${subdirs_scan_out} ]] || return 0
334
335 echo "${subdirs_scan_out}" | gawk \
336 '($0 !~ /^[[:space:]]*(#|dnl)/) {
337 if (match($0, /AC_CONFIG_SUBDIRS:(.*)$/, res))
338 print res[1]
339 }' | uniq
340
341 return 0
342 }
343
344 autotools_get_auxdir() {
345 local auxdir_scan_out
346
347 auxdir_scan_out=$(autotools_check_macro "AC_CONFIG_AUX_DIR")
348 [[ -n ${auxdir_scan_out} ]] || return 0
349
350 echo ${auxdir_scan_out} | gawk \
351 '($0 !~ /^[[:space:]]*(#|dnl)/) {
352 if (match($0, /AC_CONFIG_AUX_DIR:(.*)$/, res))
353 print res[1]
354 }' | uniq
355
356 return 0
357 }

  ViewVC Help
Powered by ViewVC 1.1.20